<template>
    <div
        v-if="componentReady"
        :class="{
            'size-lg': size === 'lg',
            'dark': !!dark
        }"
    >
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div class="mt-1 rounded-sm shadow-sm">
            <div
                class="flex flex-wrap justify-start space-x-2 w-full"
            >
                <input
                    v-for="(box, i) in boxes"
                    :ref="el => { if (el) divs[parseInt(i)] = el }"
                    :key="i"
                    :value="box.value"
                    :disabled="disabled"
                    :autocomplete="autocomplete"
                    type="number"
                    class="pin-input text-center rounded-lg"
                    :class="{
                        'w-8 h-8': size !== 'lg',
                        'w-12 h-12': size === 'lg'
                    }"
                    @keyup="(e) => triggerCheck(e, box, i)"
                    @change="triggerEmit"
                    @focusin="(e) => selectInput(e, i)"
                >
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, nextTick, onBeforeUpdate, onMounted, reactive, ref, watch} from 'vue';
const props = defineProps({
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    autocomplete: {
        required: false,
        type: Boolean,
        default: false,
    },
    digits: {
        type: [Number, String],
        default: 6,
        required: false
    },
    size: {
        required: false,
        type: String,
        default: 'md',
    },
    dark: {
        required: false,
        type: Boolean,
        default: false,
    }
});

const emit = defineEmits(['update:modelValue']);

const componentReady = ref(false);
let data = ref(props.modelValue);
let boxes = ref([]);
const divs = ref([]);

const pin = computed(() => {
    let s = '';
    boxes.value.forEach(v => {
        if (v.value) s+= String(v.value);
    });

    return s;
});

const triggerCheck = async (e, box, i) => {
    let div = divs.value[parseInt(i)];
    let v = div.value;
    //TAB do nothing
    if ((parseInt(e.which) === 9 || parseInt(e.keyCode) === 9 || e.key === 'Tab' || e.keyIdentifier === 'U+0009')) {
        return;
    } else if (i > 0 && (parseInt(e.which) === 8 || parseInt(e.keyCode) === 8 || e.key === 'Backspace' || e.keyIdentifier === 'U+0008') && (!v || !v.length)) {
        let prev_div = divs.value[parseInt(i) - 1];
        prev_div.value = null;
        boxes.value[parseInt(i)].value = '';
        if (parseInt(i) - 1 >= 0) {
            divs.value[parseInt(i) - 1].focus();
        }
    } else {
        if (String(v).length) {
            v = v.replace(/[^0-9]/g, '');

            if (v.length > 1) {
                v = v.substring(0, 1);
            }

            div.value = v;
            boxes.value[i].value = v;

            if (typeof divs.value[parseInt(i) + 1] !== 'undefined') {
                divs.value[parseInt(i) + 1].focus();
            } else {
                if (document.activeElement) {
                    document.activeElement.blur();
                }
            }
        } else {
            div.value = '';
            boxes.value[i].value = '';
        }
    }

    return true;
};

const triggerEmit = async () => {
    emit('update:modelValue', pin.value);
    return true;
};

const selectInput = (e, i) => {
    if (e.target.value.length) {
        try {
            e.target.setSelectionRange(0, e.target.value.length);
        } catch (err) {
            e.target.select();
        }
    }
};

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
});

onBeforeUpdate(() => {
    divs.value = [];
});

onMounted(async () => {
    let t = [];
    for (let i = 0; i < parseInt(props.digits); i++) {
        t.push({
            key: i,
            value: '',
        });
    }
    boxes.value = t;
    await nextTick(() => {
        componentReady.value = true;
    });
});
</script>
